import Service from './Service';
import LocalStorage from "../modules/localStorage/LocalStorage";

class PermissionService extends Service {

    constructor(permissionList) {
        super();
        let localStorage = new LocalStorage();
        this.adminConnect = localStorage.getItem('adminConnect', true);
        this.adminConnectConfig = localStorage.getItem('adminConnectConfig', true);

        this.baseUrl = this.adminConnectConfig.baseUrl + this.adminConnectConfig.permissionsUrl;
        this.permissionList = permissionList;
        console.log("PermissionService");
    }

    list() {
        let options = {};
        options.headers = new Headers({
            'Accept':                      'application/json',
            'Access-Control-Allow-Origin': '*',
            'Ubi-AppId':                   this.adminConnect.AdminConnectSession.ApplicationId,
            'Ubi-SessionId':               this.adminConnect.AdminConnectSession.sessionId,
            'Authorization':               'ubi_v1 t=' + this.adminConnect.AdminConnectSession.ticket,
        });

        options.method = 'GET';
        return this.httpClient(this.baseUrl, options).then(response => {
            return this.buildPermissions(response.json.globalPermissions);
        }).catch(error => {
            console.log(error);
        })
    }

    buildPermissions(adminConnectPermissions) {
        let permissions = [];
        adminConnectPermissions.forEach(function (value) {

            if (typeof this.permissionList[value] !== 'undefined') {
                permissions.push(this.permissionList[value]);
            }
        },this);
        return permissions;
    }
}

export default PermissionService;